/**********************************************************************
MAND.C - Mandelbrot set pure C
**********************************************************************/

# include <graphics.h>
# include <dos.h>
# include <stdio.h>
# include <stdlib.h>


int GraphDriver, GraphMode, i, j, n;
float a, b, lp1, lp2;

float cnst4 = 4.0f;
int maxi = 1000;

int iterate (float re, float im)
{
  float x = 0.0f,
  y = 0.0f,
  x2 = 0.0f,
  y2 = 0.0f;

  int n = 0;

  while(n < maxi && x2 + y2 < cnst4) {
    y = 2 * x * y + im;
    x = x2 - y2 + re;
    x2 = x * x;
    y2 = y * y;
    n++;
  }

  return(n);

}


void main(void)
{
  GraphDriver = installuserdriver("SVGA", NULL);

  GraphMode = 5;
  GraphDriver = GraphDriver + 5;
  initgraph(&GraphDriver, &GraphMode, "");

  lp1 = 3.2f / 1024f;
  lp2 = 2.4f / 768f;
  b = -1.2f;

  for(i = 0; i < 768; i++) {
    b = b + lp2;
    a = -2.4f;

    for(j = 0; j < 1024; j++) {
      a = a + lp1;

      n = iterate(a, b);
      if(n < maxi) putpixel(j, i, n);

    }
  }
  closegraph();
  exit(0);
}

